=== modified file 'bzrlib/rio.py'
--- bzrlib/rio.py	2006-02-17 20:37:19 +0000
+++ bzrlib/rio.py	2006-02-17 20:44:17 +0000
@@ -93,7 +93,8 @@
         ## elif isinstance(value, (int, long)):
         ##    value = str(value)           # XXX: python2.4 without L-suffix
         else:
-            raise ValueError("invalid value %r" % value)
+            raise TypeError("invalid type for rio value: %r of type %s"
+                            % (value, type(value)))
         self.items.append((tag, value))
         
     def __contains__(self, find_tag):

=== modified file 'bzrlib/tests/test_rio.py'
--- bzrlib/tests/test_rio.py	2005-11-28 08:35:56 +0000
+++ bzrlib/tests/test_rio.py	2006-02-17 20:44:17 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005 by Canonical Ltd
+# Copyright (C) 2005, 2006 by Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -280,3 +280,13 @@
         """Write empty stanza"""
         l = list(Stanza().to_lines())
         self.assertEquals(l, [])
+
+    def test_rio_raises_type_error(self):
+        """TypeError on adding invalid type to Stanza"""
+        s = Stanza()
+        self.assertRaises(TypeError, s.add, 'foo', {})
+
+    def test_rio_raises_type_error_key(self):
+        """TypeError on adding invalid type to Stanza"""
+        s = Stanza()
+        self.assertRaises(TypeError, s.add, 10, {})

